﻿/****************************************************************************
*Copyright (c) 2018 Microsoft All Rights Reserved.
*CLR版本： 4.0.30319.42000
*机器名称：WENLI-PC
*公司名称：Microsoft
*命名空间：WCFService
*文件名： WCFServiceFactory
*版本号： V1.0.0.0
*唯一标识：a8174a6d-04c1-4048-9bd4-f97b8f0bd8e7
*当前的用户域：WENLI-PC
*创建人： yswenli
*电子邮箱：wenguoli_520@qq.com
*创建时间：2018/5/24 14:57:12
*描述：
*
*=====================================================================
*修改标记
*修改时间：2018/5/24 14:57:12
*修改人： yswenli
*版本号： V1.0.0.0
*描述：
*
*****************************************************************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Text;
using System.Threading.Tasks;

namespace WCFService
{
    static class WCFServiceFactory
    {
        /// <summary>
        /// 快速创建一个WCF服务
        /// 需要在App.config中添加相关wcf配置
        /// </summary>
        /// <param name="serviceType"></param>
        /// <param name="baseAddress"></param>
        /// <returns></returns>
        public static ServiceHost Create(Type serviceType, Uri baseAddress)
        {
            var serviceHost = new ServiceHost(serviceType, baseAddress);

            return serviceHost;
        }

        /// <summary>
        /// 快速创建一个WCF http服务
        /// </summary>
        /// <param name="contractType"></param>
        /// <param name="serviceType"></param>
        /// <param name="url"></param>
        /// <param name="timeout"></param>
        /// <param name="bufferSize"></param>
        /// <param name="isDebug"></param>
        /// <returns></returns>
        public static ServiceHost CreateService(Type contractType, Type serviceType, string url, TimeSpan timeout, long bufferSize = 2147483647, bool isDebug = true)
        {
            Uri baseAddress = new Uri(url);

            var serviceHost = new ServiceHost(serviceType, baseAddress);


            //创建 WebHttpBinding
            var binding = new NetTcpBinding(SecurityMode.None);

            binding.MaxBufferPoolSize = binding.MaxReceivedMessageSize = bufferSize;

            binding.OpenTimeout = binding.CloseTimeout = binding.SendTimeout = binding.ReceiveTimeout = timeout;


            var readerQuotas = new System.Xml.XmlDictionaryReaderQuotas();

            readerQuotas.MaxArrayLength = readerQuotas.MaxBytesPerRead = readerQuotas.MaxDepth =
                readerQuotas.MaxNameTableCharCount = readerQuotas.MaxStringContentLength = (int)bufferSize;

            binding.ReaderQuotas = readerQuotas;

            //添加 serverbehavior
            if (serviceHost.Description.Behaviors.Find<ServiceMetadataBehavior>() == null)
            {
                ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();

                behavior.HttpGetEnabled = false;

                //behavior.HttpsGetEnabled = false;

                serviceHost.Description.Behaviors.Add(behavior);
            }

            if (serviceHost.Description.Behaviors.Find<ServiceThrottlingBehavior>() == null)
            {
                ServiceThrottlingBehavior behavior = new ServiceThrottlingBehavior();

                behavior.MaxConcurrentCalls = behavior.MaxConcurrentInstances = behavior.MaxConcurrentSessions = (int)bufferSize;

                serviceHost.Description.Behaviors.Add(behavior);
            }
            //添加 serverendpoint
            var serviceEndpoint = serviceHost.AddServiceEndpoint(contractType, binding, baseAddress);

            var serviceEndpoint2 = serviceHost.AddServiceEndpoint(contractType, binding, "net.tcp://127.0.0.1:39654/mex");


            //添加 serverendpoint 的behavior

            serviceHost.Opened += delegate
            {
                Console.WriteLine("{0}已启动！", serviceType.Name);
            };

            return serviceHost;
        }
    }
}
